MinutiaeQuest = Minutiae:NewModule("MinutiaeQuest", "AceConsole-3.0", "AceEvent-3.0")
local questIndex, isTrivial, isRepeatable, isComplete

function MinutiaeQuest:OnEnable()
	self:RegisterEvent("QUEST_DETAIL")
	self:RegisterEvent("QUEST_ACCEPTED")
	self:RegisterEvent("QUEST_ACCEPT_CONFIRM")
	self:RegisterEvent("QUEST_PROGRESS")
	self:RegisterEvent("QUEST_COMPLETE")
	self:RegisterEvent("QUEST_GREETING")
	self:RegisterEvent("GOSSIP_SHOW")
	ORIG_ERR_QUEST_ACCEPTED_S = ERR_QUEST_ACCEPTED_S
	if not Minutiae.db.global.questAccept and not Minutiae.db.global.questTurnin then
        self:Disable()
	end
end

function MinutiaeQuest:OnDisable()
	self:UnregisterEvent("QUEST_DETAIL")
	self:UnregisterEvent("QUEST_ACCEPTED")
	self:UnregisterEvent("QUEST_ACCEPT_CONFIRM")
	self:UnregisterEvent("QUEST_PROGRESS")
	self:UnregisterEvent("QUEST_COMPLETE")
	self:UnregisterEvent("QUEST_GREETING")
	self:UnregisterEvent("GOSSIP_SHOW")
	ERR_QUEST_ACCEPTED_S = ORIG_ERR_QUEST_ACCEPTED_S
end

function MinutiaeQuest:QUEST_DETAIL()
	ERR_QUEST_ACCEPTED_S = nil
		if IsShiftKeyDown() or not Minutiae.db.global.questAccept then
			return
		end
	isRepeatable = QuestIsDaily() or QuestIsWeekly()
	if not isTrivial and not isRepeatable then
		AcceptQuest()
	elseif Minutiae.db.global.lowLevel then
        if Minutiae.db.global.repeatable then
		AcceptQuest()
	elseif not isRepeatable then
		AcceptQuest()
	end
	elseif Minutiae.db.global.repeatable then
		if not isTrivial then
			AcceptQuest()
		end
	end
end

function MinutiaeQuest:QUEST_GREETING()
    if IsShiftKeyDown() or (not Minutiae.db.global.questAccept and not Minutiae.db.global.questTurnin) then
		return
	end
    for i=GetNumAvailableQuests(),1,-1 do
        isTrivial, isRepeatable = GetAvailableQuestInfo(i)
        if not isTrivial then
            if isRepeatable == 1 then
                SelectAvailableQuest(i)
            elseif Minutiae.db.global.repeatable then
                SelectAvailableQuest(i)
            end
        elseif Minutiae.db.global.lowLevel then
            if Minutiae.db.global.repeatable then
                SelectAvailableQuest(i)
            elseif isRepeatable == 1 then
                SelectAvailableQuest(i)
            end
        end
    end
    if Minutiae.db.global.questTurnin then
        for i=GetNumActiveQuests(),1,-1 do
            if select(2, GetActiveTitle(i)) then
                SelectActiveQuest(i)
            end
        end
    end
end

function MinutiaeQuest:GOSSIP_SHOW()
    if IsShiftKeyDown() or (not Minutiae.db.global.questAccept and not Minutiae.db.global.questTurnin) then
		return
	end
    if Minutiae.db.global.questAccept then
        for i=7*GetNumGossipAvailableQuests(),1,-7 do
            isTrivial = select(i-4,GetGossipAvailableQuests())
            isRepeatable = select(i-2,GetGossipAvailableQuests())
            local frequency = select(i-3,GetGossipAvailableQuests())
            if not isTrivial then
                if not isRepeatable and frequency == 1 then
                    SelectGossipAvailableQuest(i/7)
                elseif Minutiae.db.global.repeatable then
                    SelectGossipAvailableQuest(i/7)
                end
            elseif Minutiae.db.global.lowLevel then
                if Minutiae.db.global.repeatable then
                    SelectGossipAvailableQuest(i/7)
                elseif not isRepeatable and frequency == 1 then
                    SelectGossipAvailableQuest(i/7)
                end
            end
        end
    end
    if Minutiae.db.global.questTurnin then
        for i=6*GetNumGossipActiveQuests(), 1, -6 do
            if select(i-2,GetGossipActiveQuests()) and Minutiae.db.global.questTurnin then
                SelectGossipActiveQuest(i/6)
            end
        end
    end
end

function MinutiaeQuest:QUEST_ACCEPTED(_, _, questIndex, _)
	print("|cFF7FFFBEMinutiae|cFFFFFFFF: Accepted: "..GetQuestLink(questIndex))
	CloseQuest()
end

function MinutiaeQuest:QUEST_ACCEPT_CONFIRM()
	if IsShiftKeyDown() or not Minutiae.db.global.questAccept then
		return
	end
	ConfirmAcceptQuest()
	StaticPopup_Hide("QUEST_ACCEPT")
	AcknowledgeAutoAcceptQuest()
end

function MinutiaeQuest:QUEST_PROGRESS()
    if IsShiftKeyDown() or not Minutiae.db.global.questTurnin then
		return
	end
    if IsQuestCompletable() then
        CompleteQuest()
	end
end

function MinutiaeQuest:QUEST_COMPLETE()
	if IsShiftKeyDown() or not Minutiae.db.global.questTurnin then
		return
	end
    if GetNumQuestChoices() < 2 then
		GetQuestReward(GetNumQuestChoices())
	end
end
